package md

import (
	"applet/app/db/model"
)

type RoleListResp struct {
	Data      model.Role `json:"data"`
	AdminList []struct {
		Name string `json:"name"`
	} `json:"admin_list"`
}

type UpdateRoleStateReq struct {
	RoleId int `json:"role_id" binding:"required" label:"id"`
	State  int `json:"state" binding:"required" label:"状态"`
}

type AddRoleReq struct {
	Name string `json:"name" binding:"required" label:"名称"`
	Memo string `json:"memo" binding:"required" label:"备注"`
}

type UpdateRoleReq struct {
	RoleId int    `json:"role_id" binding:"required" label:"id"`
	Name   string `json:"name" binding:"required" label:"名称"`
	Memo   string `json:"memo" binding:"required" label:"备注"`
}

type RoleBindPermissionGroupReq struct {
	RoleId        int   `json:"role_id" binding:"required" label:"id"`
	PermissionIds []int `json:"permission_ids" label:"权限组id"`
}

type PermissionGroupListResp struct {
	Id                     int                       `json:"id"`
	Name                   string                    `json:"name"`
	Key                    string                    `json:"key"`
	State                  int                       `json:"state"`
	ParentId               int                       `json:"parent_id"`
	CreateAt               string                    `json:"create_at"`
	UpdateAt               string                    `json:"update_at"`
	IsCheck                bool                      `json:"is_check"`
	SubPermissionGroupList []PermissionGroupListResp `json:"sub_permission_group_list"`
}

type AdminListReq struct {
	Limit    int    `json:"limit"`
	Page     int    `json:"page" `
	UserName string `json:"username"`
	State    int    `json:"state"`
}

type AdminListResp struct {
	AdmId                int      `json:"adm_id"`
	Username             string   `json:"username"`
	State                int32    `json:"state"`
	IsSuperAdministrator int32    `json:"is_super_administrator"`
	Memo                 string   `json:"memo"`
	CreateAt             string   `json:"create_at"`
	UpdateAt             string   `json:"update_at"`
	RoleList             []string `json:"role_list"`
}

type UpdateAdminStateReq struct {
	AdmId int   `json:"adm_id" binding:"required" label:"管理员id"`
	State int32 `json:"state" binding:"required" label:"状态"`
}

type AddAdminReq struct {
	Username string `json:"username" binding:"required" label:"名称"`
	Password string `json:"password" binding:"required" label:"密码"`
	Memo     string `json:"memo"  label:"备注"`
}

type UpdateAdminReq struct {
	AdmId    int    `json:"adm_id" binding:"required" label:"管理员id"`
	Username string `json:"username" binding:"required" label:"名称"`
	Password string `json:"password" binding:"required" label:"密码"`
	Memo     string `json:"memo"  label:"备注"`
}

type BindAdminRoleReq struct {
	AdmId   int   `json:"adm_id" binding:"required" label:"管理员id"`
	RoleIds []int `json:"role_ids" label:"角色id"`
}

type BindAdminWithEnterpriseReq struct {
	AdmId int   `json:"adm_id" binding:"required" label:"管理员id"`
	Ids   []int `json:"ids" label:"记录id"`
}
