package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type NursingHomePackageOrdForReserve struct {
	Db         *xorm.Engine `json:"db"`
	OutTradeNo string       `json:"out_trade_no"`
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) Set(outTradeNo string) { // set方法
	nursingHomePackageOrdForReserveDb.Db = Db
	nursingHomePackageOrdForReserveDb.OutTradeNo = outTradeNo
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) GetNursingHomePackageOrdForReserveById(id int) (m *model.NursingHomePackageOrdForReserve, err error) {
	m = new(model.NursingHomePackageOrdForReserve)
	has, err := nursingHomePackageOrdForReserveDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) GetNursingHomePackageOrdForReserve() (m *model.NursingHomePackageOrdForReserve, err error) {
	m = new(model.NursingHomePackageOrdForReserve)
	has, err := nursingHomePackageOrdForReserveDb.Db.Where("out_trade_no =?", nursingHomePackageOrdForReserveDb.OutTradeNo).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) NursingHomePackageOrdForReserveInsert(m *model.NursingHomePackageOrdForReserve) (int, error) {
	_, err := nursingHomePackageOrdForReserveDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) NursingHomePackageOrdForReserveInsertBySession(session *xorm.Session, m *model.NursingHomePackageOrdForReserve) (int, error) {
	_, err := session.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) BatchAddNursingHomePackageOrdForReserves(mm []*model.NursingHomePackageOrdForReserve) (int64, error) {
	affected, err := nursingHomePackageOrdForReserveDb.Db.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) NursingHomePackageOrdForReserveDeleteById(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.NursingHomePackageOrdForReserve{})
	} else {
		return Db.Where("id = ?", id).Delete(model.NursingHomePackageOrdForReserve{})
	}
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) NursingHomePackageOrdForReserveDelete() (int64, error) {
	return Db.Where("out_trade_no = ?", nursingHomePackageOrdForReserveDb.OutTradeNo).Delete(model.NursingHomePackageOrdForReserve{})
}

func (nursingHomePackageOrdForReserveDb *NursingHomePackageOrdForReserve) NursingHomePackageOrdForReserveUpdate(m *model.NursingHomePackageOrdForReserve, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = nursingHomePackageOrdForReserveDb.Db.Where("out_trade_no=?", nursingHomePackageOrdForReserveDb.OutTradeNo).Cols(forceColums...).Update(m)
	} else {
		affected, err = nursingHomePackageOrdForReserveDb.Db.Where("out_trade_no=?", nursingHomePackageOrdForReserveDb.OutTradeNo).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

type NursingHomePackageOrdForReserveWithUserIdentity struct {
	model.NursingHomePackageOrdForReserve `xorm:"extends"`
	model.NursingHomePackageOrd           `xorm:"extends"`
	model.UserIdentity                    `xorm:"extends"`
	model.Enterprise                      `xorm:"extends"`
	model.User                            `xorm:"extends"`
}

func (NursingHomePackageOrdForReserveWithUserIdentity) TableName() string {
	return "nursing_home_package_ord_for_reserve"
}
