package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type SelfSupportForSchoolOrd struct {
	Db         *xorm.Engine `json:"db"`
	OutOrderNo string       `json:"user_identity_id"`
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) Set(outOrderNo string) { // set方法
	selfSupportForSchoolOrdOrdDb.Db = Db
	selfSupportForSchoolOrdOrdDb.OutOrderNo = outOrderNo
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) GetSelfSupportForSchoolOrdById(id int) (m *model.SelfSupportForSchoolOrd, err error) {
	m = new(model.SelfSupportForSchoolOrd)
	has, err := selfSupportForSchoolOrdOrdDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) GetSelfSupportForSchoolOrd() (m *model.SelfSupportForSchoolOrd, err error) {
	m = new(model.SelfSupportForSchoolOrd)
	has, err := selfSupportForSchoolOrdOrdDb.Db.Where("out_trade_no =?", selfSupportForSchoolOrdOrdDb.OutOrderNo).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) SelfSupportForSchoolOrdInsert(m *model.SelfSupportForSchoolOrd) (int, error) {
	_, err := selfSupportForSchoolOrdOrdDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) SelfSupportForSchoolOrdInsertBySession(session *xorm.Session, m *model.SelfSupportForSchoolOrd) (int, error) {
	_, err := session.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) BatchAddSelfSupportForSchoolOrds(mm []*model.SelfSupportForSchoolOrd) (int64, error) {
	affected, err := selfSupportForSchoolOrdOrdDb.Db.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) SelfSupportForSchoolOrdDeleteById(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.SelfSupportForSchoolOrd{})
	} else {
		return Db.Where("id = ?", id).Delete(model.SelfSupportForSchoolOrd{})
	}
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) SelfSupportForSchoolOrdDelete() (int64, error) {
	return Db.Where("out_trade_no = ?", selfSupportForSchoolOrdOrdDb.OutOrderNo).Delete(model.SelfSupportForSchoolOrd{})
}

func (selfSupportForSchoolOrdOrdDb *SelfSupportForSchoolOrd) SelfSupportForSchoolOrdUpdate(m *model.SelfSupportForSchoolOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = selfSupportForSchoolOrdOrdDb.Db.Where("out_trade_no=?", selfSupportForSchoolOrdOrdDb.OutOrderNo).Cols(forceColums...).Update(m)
	} else {
		affected, err = selfSupportForSchoolOrdOrdDb.Db.Where("out_trade_no=?", selfSupportForSchoolOrdOrdDb.OutOrderNo).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

type SelfSupportForSchoolOrdWithUserIdentity struct {
	model.SelfSupportForSchoolOrd `xorm:"extends"`
	model.UserIdentity            `xorm:"extends"`
	model.Enterprise              `xorm:"extends"`
	model.User                    `xorm:"extends"`
	model.ClassWithUser           `xorm:"extends"`
	model.Class                   `xorm:"extends"`
	model.Grade                   `xorm:"extends"`
}

func (SelfSupportForSchoolOrdWithUserIdentity) TableName() string {
	return "self_support_for_school_ord"
}
